/* Jason Zhu
Section E
jlzhu@andrew.cmu.edu
Project-10
*/

var terrainSpeed = 0.0003;
var terrainDetail = 0.0008;
var worms = [];

function setup() {
    createCanvas(480, 300);
    frameRate(100);
    for (var i = 0; i < 10; i++){
        var rx = random(width);
        worms[i] = makeWorm(rx);
    }
}

function draw() {
    background(246,201,116)
    push();
    beginShape(); 
    noStroke();
    fill('green')
    vertex(0, height);
    for (var x = 0; x < width; x++) {
        var t = (x * terrainDetail) + (millis() * terrainSpeed);
        var y = map(noise(t), 0, 1, 0, height);
        vertex(x, y - 50); 
    }
    vertex(width, height)
    endShape();
    pop();
    updateAndDisplay();
    removeWorms();
    addWorms(); 
}

function updateAndDisplay(){
    // Update the worms' positions, and display them.
    for (var i = 0; i < worms.length; i++){
        worms[i].move();
        worms[i].display();
    }
}

function removeWorms(){
    var wormsToKeep = [];
    for (var i = 0; i < worms.length; i++){
        if (worms[i].x + worms[i].breadth > 0) {
            wormsToKeep.push(worms[i]);
        }
    }
    worms = wormsToKeep; // remember the surviving car
}

function addWorms() {
    // With a very tiny probability, add a new car to the end.
    var likelihood = 0.007; 
    if (random(0,1) < likelihood) {
        worms.push(makeWorm(width));
    }
}

// method to update position of worm every frame
function wormMove() {
    this.x += this.speed;
}
    

// draw the worm
function wormDisplay() {
    noStroke();
    // worm body
    push();
    translate(this.x, height-50);
    fill(random(255),random(255),random(255));
    rect(5,0,this.breadth,10)
    // worm head
    rect(0,0,5,8);
    // worm eyes
    fill(5);
    ellipse(0,2,2,2);
    ellipse(8,2,2,2);
    pop();
}

function makeWorm(birthLocationX) {
    var worm = {x: birthLocationX,
                breadth: 60,
                speed: -.75,
                move: wormMove,
                display: wormDisplay}
    return worm;
}